<?php
/**
 * Created by PhpStorm.
 * User: leonardocarvalho
 * Date: 01/03/2016
 * Time: 10:57
 */

namespace HCM\Geral\Controllers;

use \Zeedhi\Framework\DTO\Response;
use HCM\Util\Util;

class GpeEscalastrabController {

    protected $escalastrabService;

    public function __construct(\HCM\Geral\Services\GpeEscalastrabService $escalastrabService) {
        $this->escalastrabService = $escalastrabService;
    }

    public function getEscalastrab($request, $response) {

        try {

            $filters = $request->getFilterCriteria()->getConditions();
            $parameters = array();
            foreach ($filters as $filter) {
                unset($filter['operator']);
                foreach ($filter as $key => $value) {
                    if ($key == 'columnName') {
                        $parameters[$value] = $filter['value'];
                    }
                }
            }
            Util::getValueInFilterDataSourceByName($filters, array('P_NRORG', 'P_DTMESCOMPETENC'), true);
            $conditions = Util::createQueryFiltered($filters);    
            $result = $this->escalastrabService->getEscalastrab($parameters, $conditions);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getEscalastrab', $result));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

    }

}