<?php

namespace HCM\VAB\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use HCM\Util\HCMParameters;

class TarifatransporteController extends Crud {

    protected $dataSourceName = 'tarifatransporte';

    protected $parameterBagColumns = array('P_NRORG', 'P_NRORG_PADRAO');

    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, HCMParameters $hcmParameters){
        $this->parameterBag = $parameterBag;
        $this->hcmParameters = $hcmParameters;
        parent::__construct($dataSourceManager);
    }

    public function getTarifatransporte (DTO\Request\Filter $request, DTO\Response $response) {
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData); 
        $response->addDataSet($dataSet);
    }

    public function setTarifatransporte (DTO\Request\DataSet $request, DTO\Response $response) {
        $retorno = array();
        foreach($request->getDataSet()->getRows() as &$row) {
            if(array_key_exists('NRTARIFA', $row)){
                if($row['NRTARIFA'] === '' ){
                    $row['NRTARIFA'] = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgPadrao(), 'VAB_TARIFA', 1, 12, true);
                }
            } else {
                $row['NRTARIFA'] = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgPadrao(), 'VAB_TARIFA', 1, 12, true);
            }
            $retorno['NRTARIFA'] = $row['NRTARIFA'];
            $retorno['DSTARIFA'] = $row['DSTARIFA'];
            $retorno['VRTARIFA'] = $row['VRTARIFA'];
        }

        parent::save($request, $response);
        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('setTarifatransporte', $retorno));
        return true;
    }

    public function delete(DTO\Request\DataSet $request, DTO\Response $response){
        parent::delete($request, $response);
    }

    protected function processConditionValue($condition) {
        return $condition['value'];
    }
    protected function populateParameterBag(FilterCriteria $filterCriteria) {

        $conditions = array();
        foreach ($filterCriteria->getConditions() as $condition) {
            $columnName = $condition['columnName'];
            if (in_array($columnName, $this->parameterBagColumns)) {
                $this->parameterBag->set($columnName, $this->processConditionValue($condition));
            } else {
                $conditions[] = $condition;
            }
        }
        $newFilterCriteria = new FilterCriteria(
            $filterCriteria->getDataSourceName(),
            $conditions,
            $filterCriteria->getPage(),
            $filterCriteria->getPageSize()
        );


        return $newFilterCriteria;
    }
}